algebra-3.1: Constructive abstract algebra

Safe Haskell | None

Numeric.Rig.Class

Synopsis

- class (Semiring r, Unital r, Monoidal r) => Rig r where
  - fromNatural :: Natural -> r
- fromNaturalNum :: Num r => Natural -> r
- fromWhole :: (Whole n, Rig r) => n -> r

# Documentation

class (Semiring r, Unital r, Monoidal r) => Rig r where Source

A Ring without (n)egation

Methods

fromNatural :: Natural -> rSource

Instances

Rig Bool |
Rig Int |
Rig Int8 |
Rig Int16 |
Rig Int32 |
Rig Int64 |
Rig Integer |
Rig Word |
Rig Word8 |
Rig Word16 |
Rig Word32 |
Rig Word64 |
Rig () |
Rig Natural |
Rig Euclidean |
(Commutative r, Ring r) => Rig (Complex r) |
(TriviallyInvolutive r, Ring r) => Rig (Quaternion r) |
(Commutative r, Ring r) => Rig (Dual r) |
(Commutative r, Rig r) => Rig (Hyper' r) |
(Commutative r, Rig r) => Rig (Hyper r) |
(Commutative r, Ring r) => Rig (Dual' r) |
Rig (BasisCoblade m) |
(TriviallyInvolutive r, Ring r) => Rig (Quaternion' r) |
(Commutative r, Ring r) => Rig (Trig r) |
(Abelian r, Monoidal r) => Rig (End r) |
Rig r => Rig (Opposite r) |
Rng r => Rig (RngRing r) |
(Rig a, Rig b) => Rig (a, b) |
(Rig r, CounitalCoalgebra r m) => Rig (Covector r m) |
(Rig a, Rig b, Rig c) => Rig (a, b, c) |
(Rig r, CounitalCoalgebra r m) => Rig (Map r b m) |
(Rig a, Rig b, Rig c, Rig d) => Rig (a, b, c, d) |
(Rig a, Rig b, Rig c, Rig d, Rig e) => Rig (a, b, c, d, e) |

fromNaturalNum :: Num r => Natural -> rSource

fromWhole :: (Whole n, Rig r) => n -> rSource